/* baobab-ringschart.c generated by valac 0.56.17, the Vala compiler
 * generated from baobab-ringschart.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2008  Igalia
 * Copyright (C) 2013  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 * Authors of the original code:
 *   Felipe Erias <femorandeira@igalia.com>
 *   Pablo Santamaria <psantamaria@igalia.com>
 *   Jacobo Aragunde <jaragunde@igalia.com>
 *   Eduardo Lima <elima@igalia.com>
 *   Mario Sanchez <msanchez@igalia.com>
 *   Miguel Gomez <magomez@igalia.com>
 *   Henrique Ferreiro <hferreiro@igalia.com>
 *   Alejandro Pinheiro <apinheiro@igalia.com>
 *   Carlos Sanmartin <csanmartin@igalia.com>
 *   Alejandro Garcia <alex@igalia.com>
 */

#include "baobab.h"
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <pango/pango.h>
#include <stdlib.h>

#define BAOBAB_RINGSCHART_ITEM_BORDER_WIDTH 1
#define BAOBAB_RINGSCHART_ITEM_MIN_ANGLE 0.03
#define BAOBAB_RINGSCHART_EDGE_ANGLE 0.004
#define BAOBAB_RINGSCHART_SUBTIP_TIMEOUT 1000
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define BAOBAB_TYPE_RINGSCHART_ITEM (baobab_ringschart_item_get_type ())
#define BAOBAB_RINGSCHART_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BAOBAB_TYPE_RINGSCHART_ITEM, BaobabRingschartItem))
#define BAOBAB_RINGSCHART_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BAOBAB_TYPE_RINGSCHART_ITEM, BaobabRingschartItemClass))
#define BAOBAB_IS_RINGSCHART_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BAOBAB_TYPE_RINGSCHART_ITEM))
#define BAOBAB_IS_RINGSCHART_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BAOBAB_TYPE_RINGSCHART_ITEM))
#define BAOBAB_RINGSCHART_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BAOBAB_TYPE_RINGSCHART_ITEM, BaobabRingschartItemClass))

typedef struct _BaobabRingschartItem BaobabRingschartItem;
typedef struct _BaobabRingschartItemClass BaobabRingschartItemClass;
typedef struct _BaobabRingschartItemPrivate BaobabRingschartItemPrivate;
enum  {
	BAOBAB_RINGSCHART_0_PROPERTY,
	BAOBAB_RINGSCHART_NUM_PROPERTIES
};
static GParamSpec* baobab_ringschart_properties[BAOBAB_RINGSCHART_NUM_PROPERTIES];
#define _baobab_chart_item_unref0(var) ((var == NULL) ? NULL : (var = (baobab_chart_item_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BaobabRingschartItem {
	BaobabChartItem parent_instance;
	BaobabRingschartItemPrivate * priv;
	gdouble min_radius;
	gdouble max_radius;
	gdouble start_angle;
	gdouble angle;
	gboolean continued;
};

struct _BaobabRingschartItemClass {
	BaobabChartItemClass parent_class;
};

struct _BaobabRingschartPrivate {
	guint tips_timeout_id;
	gboolean drawing_subtips;
	GList* subtip_items;
};

static gpointer baobab_ringschart_item_parent_class = NULL;
static gint BaobabRingschart_private_offset;
static gpointer baobab_ringschart_parent_class = NULL;

VALA_EXTERN GType baobab_ringschart_item_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BaobabRingschartItem* baobab_ringschart_item_new (void);
VALA_EXTERN BaobabRingschartItem* baobab_ringschart_item_construct (GType object_type);
static void baobab_ringschart_item_finalize (BaobabChartItem * obj);
static GType baobab_ringschart_item_get_type_once (void);
static void _baobab_chart_item_unref0_ (gpointer var);
static inline void _g_list_free__baobab_chart_item_unref0_ (GList* self);
static void baobab_ringschart_subtips_update (BaobabRingschart* self);
static gboolean ___lambda28_ (BaobabRingschart* self);
static gboolean ____lambda28__gsource_func (gpointer self);
static BaobabChartItem* baobab_ringschart_real_create_new_chartitem (BaobabChart* base);
static void baobab_ringschart_real_post_draw (BaobabChart* base,
                                       cairo_t* cr);
static void baobab_ringschart_real_draw_item (BaobabChart* base,
                                       cairo_t* cr,
                                       BaobabChartItem* item,
                                       gboolean highlighted);
static void baobab_ringschart_real_calculate_item_geometry (BaobabChart* base,
                                                     BaobabChartItem* item);
static void baobab_ringschart_get_point_min_rect (BaobabRingschart* self,
                                           gdouble cx,
                                           gdouble cy,
                                           gdouble radius,
                                           gdouble angle,
                                           GdkRectangle* r);
static void baobab_ringschart_real_get_item_rectangle (BaobabChart* base,
                                                BaobabChartItem* item);
static gboolean baobab_ringschart_real_is_point_over_item (BaobabChart* base,
                                                    BaobabChartItem* item,
                                                    gdouble x,
                                                    gdouble y);
static gboolean baobab_ringschart_real_can_zoom_out (BaobabChart* base);
static gboolean baobab_ringschart_real_can_zoom_in (BaobabChart* base);
static GObject * baobab_ringschart_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _baobab_ringschart_subtips_update_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void baobab_ringschart_finalize (GObject * obj);
static GType baobab_ringschart_get_type_once (void);

BaobabRingschartItem*
baobab_ringschart_item_construct (GType object_type)
{
	BaobabRingschartItem* self = NULL;
#line 37 "../src/baobab-ringschart.vala"
	self = (BaobabRingschartItem*) baobab_chart_item_construct (object_type);
#line 37 "../src/baobab-ringschart.vala"
	return self;
#line 157 "baobab-ringschart.c"
}

BaobabRingschartItem*
baobab_ringschart_item_new (void)
{
#line 37 "../src/baobab-ringschart.vala"
	return baobab_ringschart_item_construct (BAOBAB_TYPE_RINGSCHART_ITEM);
#line 165 "baobab-ringschart.c"
}

static void
baobab_ringschart_item_class_init (BaobabRingschartItemClass * klass,
                                   gpointer klass_data)
{
#line 37 "../src/baobab-ringschart.vala"
	baobab_ringschart_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/baobab-ringschart.vala"
	((BaobabChartItemClass *) klass)->finalize = baobab_ringschart_item_finalize;
#line 176 "baobab-ringschart.c"
}

static void
baobab_ringschart_item_instance_init (BaobabRingschartItem * self,
                                      gpointer klass)
{
}

static void
baobab_ringschart_item_finalize (BaobabChartItem * obj)
{
	BaobabRingschartItem * self;
#line 37 "../src/baobab-ringschart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_RINGSCHART_ITEM, BaobabRingschartItem);
#line 37 "../src/baobab-ringschart.vala"
	BAOBAB_CHART_ITEM_CLASS (baobab_ringschart_item_parent_class)->finalize (obj);
#line 193 "baobab-ringschart.c"
}

static GType
baobab_ringschart_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabRingschartItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_ringschart_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabRingschartItem), 0, (GInstanceInitFunc) baobab_ringschart_item_instance_init, NULL };
	GType baobab_ringschart_item_type_id;
	baobab_ringschart_item_type_id = g_type_register_static (BAOBAB_TYPE_CHART_ITEM, "BaobabRingschartItem", &g_define_type_info, 0);
	return baobab_ringschart_item_type_id;
}

GType
baobab_ringschart_item_get_type (void)
{
	static volatile gsize baobab_ringschart_item_type_id__once = 0;
	if (g_once_init_enter (&baobab_ringschart_item_type_id__once)) {
		GType baobab_ringschart_item_type_id;
		baobab_ringschart_item_type_id = baobab_ringschart_item_get_type_once ();
		g_once_init_leave (&baobab_ringschart_item_type_id__once, baobab_ringschart_item_type_id);
	}
	return baobab_ringschart_item_type_id__once;
}

static inline gpointer
baobab_ringschart_get_instance_private (BaobabRingschart* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabRingschart_private_offset);
}

static void
_baobab_chart_item_unref0_ (gpointer var)
{
#line 56 "../src/baobab-ringschart.vala"
	(var == NULL) ? NULL : (var = (baobab_chart_item_unref (var), NULL));
#line 228 "baobab-ringschart.c"
}

static inline void
_g_list_free__baobab_chart_item_unref0_ (GList* self)
{
#line 56 "../src/baobab-ringschart.vala"
	g_list_free_full (self, (GDestroyNotify) _baobab_chart_item_unref0_);
#line 236 "baobab-ringschart.c"
}

static gboolean
___lambda28_ (BaobabRingschart* self)
{
	gboolean result;
#line 73 "../src/baobab-ringschart.vala"
	self->priv->drawing_subtips = TRUE;
#line 74 "../src/baobab-ringschart.vala"
	self->priv->tips_timeout_id = (guint) 0;
#line 75 "../src/baobab-ringschart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 76 "../src/baobab-ringschart.vala"
	result = FALSE;
#line 76 "../src/baobab-ringschart.vala"
	return result;
#line 253 "baobab-ringschart.c"
}

static gboolean
____lambda28__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda28_ ((BaobabRingschart*) self);
#line 72 "../src/baobab-ringschart.vala"
	return result;
#line 263 "baobab-ringschart.c"
}

static void
baobab_ringschart_subtips_update (BaobabRingschart* self)
{
	BaobabChartItem* _tmp0_;
	BaobabChartItem* _tmp1_;
#line 58 "../src/baobab-ringschart.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/baobab-ringschart.vala"
	if (self->priv->drawing_subtips) {
#line 60 "../src/baobab-ringschart.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 277 "baobab-ringschart.c"
	}
#line 62 "../src/baobab-ringschart.vala"
	self->priv->drawing_subtips = FALSE;
#line 64 "../src/baobab-ringschart.vala"
	if (self->priv->tips_timeout_id != ((guint) 0)) {
#line 65 "../src/baobab-ringschart.vala"
		g_source_remove (self->priv->tips_timeout_id);
#line 66 "../src/baobab-ringschart.vala"
		self->priv->tips_timeout_id = (guint) 0;
#line 287 "baobab-ringschart.c"
	}
#line 69 "../src/baobab-ringschart.vala"
	(self->priv->subtip_items == NULL) ? NULL : (self->priv->subtip_items = (_g_list_free__baobab_chart_item_unref0_ (self->priv->subtip_items), NULL));
#line 69 "../src/baobab-ringschart.vala"
	self->priv->subtip_items = NULL;
#line 71 "../src/baobab-ringschart.vala"
	_tmp0_ = baobab_chart_get_highlighted_item ((BaobabChart*) self);
#line 71 "../src/baobab-ringschart.vala"
	_tmp1_ = _tmp0_;
#line 71 "../src/baobab-ringschart.vala"
	if (_tmp1_ != NULL) {
#line 72 "../src/baobab-ringschart.vala"
		self->priv->tips_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) BAOBAB_RINGSCHART_SUBTIP_TIMEOUT, ____lambda28__gsource_func, g_object_ref (self), g_object_unref);
#line 301 "baobab-ringschart.c"
	}
}

static BaobabChartItem*
baobab_ringschart_real_create_new_chartitem (BaobabChart* base)
{
	BaobabRingschart * self;
	BaobabRingschartItem* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* result;
#line 91 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 92 "../src/baobab-ringschart.vala"
	_tmp0_ = baobab_ringschart_item_new ();
#line 92 "../src/baobab-ringschart.vala"
	_tmp1_ = BAOBAB_IS_CHART_ITEM (_tmp0_) ? ((BaobabChartItem*) _tmp0_) : NULL;
#line 92 "../src/baobab-ringschart.vala"
	if (_tmp1_ == NULL) {
#line 92 "../src/baobab-ringschart.vala"
		_baobab_chart_item_unref0 (_tmp0_);
#line 322 "baobab-ringschart.c"
	}
#line 92 "../src/baobab-ringschart.vala"
	result = _tmp1_;
#line 92 "../src/baobab-ringschart.vala"
	return result;
#line 328 "baobab-ringschart.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 100 "../src/baobab-ringschart.vala"
	return self ? g_object_ref (self) : NULL;
#line 336 "baobab-ringschart.c"
}

static gpointer
_baobab_chart_item_ref0 (gpointer self)
{
#line 117 "../src/baobab-ringschart.vala"
	return self ? baobab_chart_item_ref (self) : NULL;
#line 344 "baobab-ringschart.c"
}

static void
baobab_ringschart_real_post_draw (BaobabChart* base,
                                  cairo_t* cr)
{
	BaobabRingschart * self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp4_ = {0};
	gint q_width = 0;
	GtkAllocation _tmp5_;
	gint q_height = 0;
	GtkAllocation _tmp6_;
	gdouble q_angle = 0.0;
	GdkRectangle last_rect = {0};
	GtkBorder padding = {0};
	GtkStyleContext* _tmp7_;
	GtkBorder _tmp8_ = {0};
	gint16 vpadding = 0;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
	gint16 hpadding = 0;
	GtkBorder _tmp11_;
	GtkBorder _tmp12_;
	GList* _tmp13_;
	GtkStyleContext* _tmp93_;
#line 95 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 95 "../src/baobab-ringschart.vala"
	g_return_if_fail (cr != NULL);
#line 96 "../src/baobab-ringschart.vala"
	if (!self->priv->drawing_subtips) {
#line 97 "../src/baobab-ringschart.vala"
		return;
#line 384 "baobab-ringschart.c"
	}
#line 100 "../src/baobab-ringschart.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 100 "../src/baobab-ringschart.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 100 "../src/baobab-ringschart.vala"
	context = _tmp1_;
#line 101 "../src/baobab-ringschart.vala"
	_tmp2_ = context;
#line 101 "../src/baobab-ringschart.vala"
	gtk_style_context_save (_tmp2_);
#line 102 "../src/baobab-ringschart.vala"
	_tmp3_ = context;
#line 102 "../src/baobab-ringschart.vala"
	gtk_style_context_add_class (_tmp3_, "subfolder-tip");
#line 105 "../src/baobab-ringschart.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp4_);
#line 105 "../src/baobab-ringschart.vala"
	allocation = _tmp4_;
#line 107 "../src/baobab-ringschart.vala"
	_tmp5_ = allocation;
#line 107 "../src/baobab-ringschart.vala"
	q_width = _tmp5_.width / 2;
#line 108 "../src/baobab-ringschart.vala"
	_tmp6_ = allocation;
#line 108 "../src/baobab-ringschart.vala"
	q_height = _tmp6_.height / 2;
#line 109 "../src/baobab-ringschart.vala"
	q_angle = atan2 ((gdouble) q_height, (gdouble) q_width);
#line 111 "../src/baobab-ringschart.vala"
	memset (&last_rect, 0, sizeof (GdkRectangle));
#line 113 "../src/baobab-ringschart.vala"
	_tmp7_ = context;
#line 113 "../src/baobab-ringschart.vala"
	gtk_style_context_get_padding (_tmp7_, &_tmp8_);
#line 113 "../src/baobab-ringschart.vala"
	padding = _tmp8_;
#line 114 "../src/baobab-ringschart.vala"
	_tmp9_ = padding;
#line 114 "../src/baobab-ringschart.vala"
	_tmp10_ = padding;
#line 114 "../src/baobab-ringschart.vala"
	vpadding = _tmp9_.top + _tmp10_.bottom;
#line 115 "../src/baobab-ringschart.vala"
	_tmp11_ = padding;
#line 115 "../src/baobab-ringschart.vala"
	_tmp12_ = padding;
#line 115 "../src/baobab-ringschart.vala"
	hpadding = _tmp11_.left + _tmp12_.right;
#line 117 "../src/baobab-ringschart.vala"
	_tmp13_ = self->priv->subtip_items;
#line 436 "baobab-ringschart.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 117 "../src/baobab-ringschart.vala"
		item_collection = _tmp13_;
#line 117 "../src/baobab-ringschart.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 444 "baobab-ringschart.c"
			BaobabChartItem* _tmp14_;
			BaobabChartItem* item = NULL;
#line 117 "../src/baobab-ringschart.vala"
			_tmp14_ = _baobab_chart_item_ref0 ((BaobabChartItem*) item_it->data);
#line 117 "../src/baobab-ringschart.vala"
			item = _tmp14_;
#line 451 "baobab-ringschart.c"
			{
				BaobabRingschartItem* ringsitem = NULL;
				BaobabChartItem* _tmp15_;
				BaobabRingschartItem* _tmp16_;
				gdouble middle_angle = 0.0;
				BaobabRingschartItem* _tmp17_;
				BaobabRingschartItem* _tmp18_;
				gdouble middle_angle_n = 0.0;
				PangoLayout* layout = NULL;
				PangoLayout* _tmp19_;
				gchar* markup = NULL;
				BaobabChartItem* _tmp20_;
				BaobabScannerResults* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				PangoLayout* _tmp30_;
				const gchar* _tmp31_;
				PangoLayout* _tmp32_;
				PangoLayout* _tmp33_;
				PangoLayout* _tmp34_;
				PangoLayout* _tmp35_;
				PangoRectangle layout_rect = {0};
				PangoLayout* _tmp36_;
				PangoRectangle _tmp37_ = {0};
				gdouble tip_x = 0.0;
				gdouble tip_y = 0.0;
				cairo_rectangle_t tooltip_rect = {0};
				PangoRectangle _tmp40_;
				GtkBorder _tmp41_;
				PangoRectangle _tmp42_;
				GtkBorder _tmp43_;
				PangoRectangle _tmp44_;
				PangoRectangle _tmp45_;
				gdouble a = 0.0;
				gint i = 0;
				GdkRectangle _rect = {0};
				cairo_rectangle_t _tmp53_;
				cairo_rectangle_t _tmp54_;
				cairo_rectangle_t _tmp55_;
				cairo_rectangle_t _tmp56_;
				GdkRectangle _tmp57_;
#line 118 "../src/baobab-ringschart.vala"
				_tmp15_ = item;
#line 118 "../src/baobab-ringschart.vala"
				_tmp16_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (_tmp15_) ? ((BaobabRingschartItem*) _tmp15_) : NULL);
#line 118 "../src/baobab-ringschart.vala"
				ringsitem = _tmp16_;
#line 121 "../src/baobab-ringschart.vala"
				_tmp17_ = ringsitem;
#line 121 "../src/baobab-ringschart.vala"
				_tmp18_ = ringsitem;
#line 121 "../src/baobab-ringschart.vala"
				middle_angle = _tmp17_->start_angle + (_tmp18_->angle / 2);
#line 123 "../src/baobab-ringschart.vala"
				middle_angle_n = middle_angle;
#line 124 "../src/baobab-ringschart.vala"
				while (TRUE) {
#line 124 "../src/baobab-ringschart.vala"
					if (!(middle_angle_n > (G_PI / 2))) {
#line 124 "../src/baobab-ringschart.vala"
						break;
#line 519 "baobab-ringschart.c"
					}
#line 125 "../src/baobab-ringschart.vala"
					middle_angle_n -= G_PI;
#line 523 "baobab-ringschart.c"
				}
#line 127 "../src/baobab-ringschart.vala"
				middle_angle_n = fabs (middle_angle_n);
#line 130 "../src/baobab-ringschart.vala"
				_tmp19_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
#line 130 "../src/baobab-ringschart.vala"
				layout = _tmp19_;
#line 131 "../src/baobab-ringschart.vala"
				_tmp20_ = item;
#line 131 "../src/baobab-ringschart.vala"
				_tmp21_ = _tmp20_->results;
#line 131 "../src/baobab-ringschart.vala"
				_tmp22_ = baobab_scanner_results_get_display_name (_tmp21_);
#line 131 "../src/baobab-ringschart.vala"
				_tmp23_ = _tmp22_;
#line 131 "../src/baobab-ringschart.vala"
				_tmp24_ = g_markup_escape_text (_tmp23_, (gssize) -1);
#line 131 "../src/baobab-ringschart.vala"
				_tmp25_ = _tmp24_;
#line 131 "../src/baobab-ringschart.vala"
				_tmp26_ = g_strconcat ("<span size=\"small\">", _tmp25_, NULL);
#line 131 "../src/baobab-ringschart.vala"
				_tmp27_ = _tmp26_;
#line 131 "../src/baobab-ringschart.vala"
				_tmp28_ = g_strconcat (_tmp27_, "</span>", NULL);
#line 131 "../src/baobab-ringschart.vala"
				_tmp29_ = _tmp28_;
#line 131 "../src/baobab-ringschart.vala"
				_g_free0 (_tmp27_);
#line 131 "../src/baobab-ringschart.vala"
				_g_free0 (_tmp25_);
#line 131 "../src/baobab-ringschart.vala"
				markup = _tmp29_;
#line 132 "../src/baobab-ringschart.vala"
				_tmp30_ = layout;
#line 132 "../src/baobab-ringschart.vala"
				_tmp31_ = markup;
#line 132 "../src/baobab-ringschart.vala"
				pango_layout_set_markup (_tmp30_, _tmp31_, -1);
#line 133 "../src/baobab-ringschart.vala"
				_tmp32_ = layout;
#line 133 "../src/baobab-ringschart.vala"
				pango_layout_set_indent (_tmp32_, 0);
#line 134 "../src/baobab-ringschart.vala"
				_tmp33_ = layout;
#line 134 "../src/baobab-ringschart.vala"
				pango_layout_set_spacing (_tmp33_, 0);
#line 135 "../src/baobab-ringschart.vala"
				_tmp34_ = layout;
#line 135 "../src/baobab-ringschart.vala"
				pango_layout_set_width (_tmp34_, (PANGO_SCALE * q_width) / 2);
#line 136 "../src/baobab-ringschart.vala"
				_tmp35_ = layout;
#line 136 "../src/baobab-ringschart.vala"
				pango_layout_set_ellipsize (_tmp35_, PANGO_ELLIPSIZE_END);
#line 138 "../src/baobab-ringschart.vala"
				_tmp36_ = layout;
#line 138 "../src/baobab-ringschart.vala"
				pango_layout_get_pixel_extents (_tmp36_, NULL, &_tmp37_);
#line 138 "../src/baobab-ringschart.vala"
				layout_rect = _tmp37_;
#line 142 "../src/baobab-ringschart.vala"
				if (middle_angle_n < q_angle) {
#line 587 "baobab-ringschart.c"
					PangoRectangle _tmp38_;
#line 143 "../src/baobab-ringschart.vala"
					_tmp38_ = layout_rect;
#line 143 "../src/baobab-ringschart.vala"
					tip_x = (gdouble) ((q_width - (_tmp38_.width / 2)) - hpadding);
#line 144 "../src/baobab-ringschart.vala"
					tip_y = tan (middle_angle_n) * tip_x;
#line 595 "baobab-ringschart.c"
				} else {
					PangoRectangle _tmp39_;
#line 146 "../src/baobab-ringschart.vala"
					_tmp39_ = layout_rect;
#line 146 "../src/baobab-ringschart.vala"
					tip_y = (gdouble) ((q_height - (_tmp39_.height / 2)) - vpadding);
#line 147 "../src/baobab-ringschart.vala"
					tip_x = tip_y / tan (middle_angle_n);
#line 604 "baobab-ringschart.c"
				}
#line 151 "../src/baobab-ringschart.vala"
				memset (&tooltip_rect, 0, sizeof (cairo_rectangle_t));
#line 152 "../src/baobab-ringschart.vala"
				_tmp40_ = layout_rect;
#line 152 "../src/baobab-ringschart.vala"
				_tmp41_ = padding;
#line 152 "../src/baobab-ringschart.vala"
				tooltip_rect.x = ((q_width + tip_x) - (_tmp40_.width / 2)) - _tmp41_.left;
#line 153 "../src/baobab-ringschart.vala"
				_tmp42_ = layout_rect;
#line 153 "../src/baobab-ringschart.vala"
				_tmp43_ = padding;
#line 153 "../src/baobab-ringschart.vala"
				tooltip_rect.y = ((q_height + tip_y) - (_tmp42_.height / 2)) - _tmp43_.top;
#line 154 "../src/baobab-ringschart.vala"
				_tmp44_ = layout_rect;
#line 154 "../src/baobab-ringschart.vala"
				tooltip_rect.width = (gdouble) (_tmp44_.width + hpadding);
#line 155 "../src/baobab-ringschart.vala"
				_tmp45_ = layout_rect;
#line 155 "../src/baobab-ringschart.vala"
				tooltip_rect.height = (gdouble) (_tmp45_.height + vpadding);
#line 158 "../src/baobab-ringschart.vala"
				a = middle_angle;
#line 159 "../src/baobab-ringschart.vala"
				i = 0;
#line 160 "../src/baobab-ringschart.vala"
				while (TRUE) {
#line 634 "baobab-ringschart.c"
					gint _tmp52_;
#line 160 "../src/baobab-ringschart.vala"
					if (!(a > (G_PI / 2))) {
#line 160 "../src/baobab-ringschart.vala"
						break;
#line 640 "baobab-ringschart.c"
					}
#line 161 "../src/baobab-ringschart.vala"
					if ((i % 2) == 0) {
#line 644 "baobab-ringschart.c"
						GtkAllocation _tmp46_;
						cairo_rectangle_t _tmp47_;
						cairo_rectangle_t _tmp48_;
#line 162 "../src/baobab-ringschart.vala"
						_tmp46_ = allocation;
#line 162 "../src/baobab-ringschart.vala"
						_tmp47_ = tooltip_rect;
#line 162 "../src/baobab-ringschart.vala"
						_tmp48_ = tooltip_rect;
#line 162 "../src/baobab-ringschart.vala"
						tooltip_rect.x = (_tmp46_.width - _tmp47_.x) - _tmp48_.width;
#line 656 "baobab-ringschart.c"
					} else {
						GtkAllocation _tmp49_;
						cairo_rectangle_t _tmp50_;
						cairo_rectangle_t _tmp51_;
#line 164 "../src/baobab-ringschart.vala"
						_tmp49_ = allocation;
#line 164 "../src/baobab-ringschart.vala"
						_tmp50_ = tooltip_rect;
#line 164 "../src/baobab-ringschart.vala"
						_tmp51_ = tooltip_rect;
#line 164 "../src/baobab-ringschart.vala"
						tooltip_rect.y = (_tmp49_.height - _tmp50_.y) - _tmp51_.height;
#line 669 "baobab-ringschart.c"
					}
#line 166 "../src/baobab-ringschart.vala"
					_tmp52_ = i;
#line 166 "../src/baobab-ringschart.vala"
					i = _tmp52_ + 1;
#line 167 "../src/baobab-ringschart.vala"
					a -= G_PI / 2;
#line 677 "baobab-ringschart.c"
				}
#line 171 "../src/baobab-ringschart.vala"
				memset (&_rect, 0, sizeof (GdkRectangle));
#line 172 "../src/baobab-ringschart.vala"
				_tmp53_ = tooltip_rect;
#line 172 "../src/baobab-ringschart.vala"
				_rect.x = (gint) (_tmp53_.x - 1);
#line 173 "../src/baobab-ringschart.vala"
				_tmp54_ = tooltip_rect;
#line 173 "../src/baobab-ringschart.vala"
				_rect.y = (gint) (_tmp54_.y - 1);
#line 174 "../src/baobab-ringschart.vala"
				_tmp55_ = tooltip_rect;
#line 174 "../src/baobab-ringschart.vala"
				_rect.width = (gint) (_tmp55_.width + 2);
#line 175 "../src/baobab-ringschart.vala"
				_tmp56_ = tooltip_rect;
#line 175 "../src/baobab-ringschart.vala"
				_rect.height = (gint) (_tmp56_.height + 2);
#line 178 "../src/baobab-ringschart.vala"
				_tmp57_ = last_rect;
#line 178 "../src/baobab-ringschart.vala"
				if (!gdk_rectangle_intersect (&_rect, &_tmp57_, NULL)) {
#line 701 "baobab-ringschart.c"
					GdkRectangle _tmp58_;
					cairo_rectangle_t _tmp59_;
					cairo_rectangle_t _tmp60_;
					gdouble middle_radius = 0.0;
					BaobabRingschartItem* _tmp61_;
					BaobabRingschartItem* _tmp62_;
					BaobabRingschartItem* _tmp63_;
					gdouble sector_center_x = 0.0;
					gdouble sector_center_y = 0.0;
					GtkAllocation _tmp64_;
					GtkAllocation _tmp65_;
					cairo_rectangle_t _tmp66_;
					cairo_rectangle_t _tmp67_;
					cairo_rectangle_t _tmp68_;
					cairo_rectangle_t _tmp69_;
					cairo_rectangle_t _tmp70_;
					GdkRGBA bg_color = {0};
					GdkRGBA _tmp71_ = {0};
					GdkRGBA _tmp72_;
					cairo_rectangle_t _tmp73_;
					cairo_rectangle_t _tmp74_;
					cairo_rectangle_t _tmp75_;
					cairo_rectangle_t _tmp76_;
					GtkStyleContext* _tmp77_;
					cairo_rectangle_t _tmp78_;
					cairo_rectangle_t _tmp79_;
					cairo_rectangle_t _tmp80_;
					cairo_rectangle_t _tmp81_;
					GtkStyleContext* _tmp82_;
					cairo_rectangle_t _tmp83_;
					cairo_rectangle_t _tmp84_;
					cairo_rectangle_t _tmp85_;
					cairo_rectangle_t _tmp86_;
					GtkStyleContext* _tmp87_;
					cairo_rectangle_t _tmp88_;
					GtkBorder _tmp89_;
					cairo_rectangle_t _tmp90_;
					GtkBorder _tmp91_;
					PangoLayout* _tmp92_;
#line 179 "../src/baobab-ringschart.vala"
					_tmp58_ = _rect;
#line 179 "../src/baobab-ringschart.vala"
					last_rect = _tmp58_;
#line 184 "../src/baobab-ringschart.vala"
					_tmp59_ = tooltip_rect;
#line 184 "../src/baobab-ringschart.vala"
					tooltip_rect.x = floor (_tmp59_.x);
#line 185 "../src/baobab-ringschart.vala"
					_tmp60_ = tooltip_rect;
#line 185 "../src/baobab-ringschart.vala"
					tooltip_rect.y = floor (_tmp60_.y);
#line 187 "../src/baobab-ringschart.vala"
					_tmp61_ = ringsitem;
#line 187 "../src/baobab-ringschart.vala"
					_tmp62_ = ringsitem;
#line 187 "../src/baobab-ringschart.vala"
					_tmp63_ = ringsitem;
#line 187 "../src/baobab-ringschart.vala"
					middle_radius = _tmp61_->min_radius + ((_tmp62_->max_radius - _tmp63_->min_radius) / 2);
#line 188 "../src/baobab-ringschart.vala"
					sector_center_x = q_width + (middle_radius * cos (middle_angle));
#line 189 "../src/baobab-ringschart.vala"
					sector_center_y = q_height + (middle_radius * sin (middle_angle));
#line 192 "../src/baobab-ringschart.vala"
					cairo_save (cr);
#line 196 "../src/baobab-ringschart.vala"
					_tmp64_ = allocation;
#line 196 "../src/baobab-ringschart.vala"
					_tmp65_ = allocation;
#line 196 "../src/baobab-ringschart.vala"
					cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) _tmp64_.width, (gdouble) _tmp65_.height);
#line 197 "../src/baobab-ringschart.vala"
					_tmp66_ = tooltip_rect;
#line 197 "../src/baobab-ringschart.vala"
					_tmp67_ = tooltip_rect;
#line 197 "../src/baobab-ringschart.vala"
					_tmp68_ = tooltip_rect;
#line 197 "../src/baobab-ringschart.vala"
					_tmp69_ = tooltip_rect;
#line 197 "../src/baobab-ringschart.vala"
					_tmp70_ = tooltip_rect;
#line 197 "../src/baobab-ringschart.vala"
					cairo_rectangle (cr, _tmp66_.x + _tmp67_.width, _tmp68_.y, -_tmp69_.width, _tmp70_.height);
#line 198 "../src/baobab-ringschart.vala"
					cairo_clip (cr);
#line 200 "../src/baobab-ringschart.vala"
					_tmp71_.red = (gfloat) 0;
#line 200 "../src/baobab-ringschart.vala"
					_tmp71_.green = (gfloat) 0;
#line 200 "../src/baobab-ringschart.vala"
					_tmp71_.blue = (gfloat) 0;
#line 200 "../src/baobab-ringschart.vala"
					_tmp71_.alpha = (gfloat) 0.8;
#line 200 "../src/baobab-ringschart.vala"
					bg_color = _tmp71_;
#line 201 "../src/baobab-ringschart.vala"
					cairo_set_line_width (cr, (gdouble) 1);
#line 202 "../src/baobab-ringschart.vala"
					cairo_move_to (cr, sector_center_x, sector_center_y);
#line 203 "../src/baobab-ringschart.vala"
					_tmp72_ = bg_color;
#line 203 "../src/baobab-ringschart.vala"
					gdk_cairo_set_source_rgba (cr, &_tmp72_);
#line 204 "../src/baobab-ringschart.vala"
					_tmp73_ = tooltip_rect;
#line 204 "../src/baobab-ringschart.vala"
					_tmp74_ = tooltip_rect;
#line 204 "../src/baobab-ringschart.vala"
					_tmp75_ = tooltip_rect;
#line 204 "../src/baobab-ringschart.vala"
					_tmp76_ = tooltip_rect;
#line 204 "../src/baobab-ringschart.vala"
					cairo_line_to (cr, _tmp73_.x + (_tmp74_.width / 2), _tmp75_.y + (_tmp76_.height / 2));
#line 206 "../src/baobab-ringschart.vala"
					cairo_stroke (cr);
#line 208 "../src/baobab-ringschart.vala"
					cairo_restore (cr);
#line 211 "../src/baobab-ringschart.vala"
					cairo_arc (cr, sector_center_x, sector_center_y, 1.0, (gdouble) 0, 2 * G_PI);
#line 212 "../src/baobab-ringschart.vala"
					cairo_stroke (cr);
#line 215 "../src/baobab-ringschart.vala"
					_tmp77_ = context;
#line 215 "../src/baobab-ringschart.vala"
					_tmp78_ = tooltip_rect;
#line 215 "../src/baobab-ringschart.vala"
					_tmp79_ = tooltip_rect;
#line 215 "../src/baobab-ringschart.vala"
					_tmp80_ = tooltip_rect;
#line 215 "../src/baobab-ringschart.vala"
					_tmp81_ = tooltip_rect;
#line 215 "../src/baobab-ringschart.vala"
					gtk_render_background (_tmp77_, cr, _tmp78_.x, _tmp79_.y, _tmp80_.width, _tmp81_.height);
#line 216 "../src/baobab-ringschart.vala"
					_tmp82_ = context;
#line 216 "../src/baobab-ringschart.vala"
					_tmp83_ = tooltip_rect;
#line 216 "../src/baobab-ringschart.vala"
					_tmp84_ = tooltip_rect;
#line 216 "../src/baobab-ringschart.vala"
					_tmp85_ = tooltip_rect;
#line 216 "../src/baobab-ringschart.vala"
					_tmp86_ = tooltip_rect;
#line 216 "../src/baobab-ringschart.vala"
					gtk_render_frame (_tmp82_, cr, _tmp83_.x, _tmp84_.y, _tmp85_.width, _tmp86_.height);
#line 217 "../src/baobab-ringschart.vala"
					_tmp87_ = context;
#line 217 "../src/baobab-ringschart.vala"
					_tmp88_ = tooltip_rect;
#line 217 "../src/baobab-ringschart.vala"
					_tmp89_ = padding;
#line 217 "../src/baobab-ringschart.vala"
					_tmp90_ = tooltip_rect;
#line 217 "../src/baobab-ringschart.vala"
					_tmp91_ = padding;
#line 217 "../src/baobab-ringschart.vala"
					_tmp92_ = layout;
#line 217 "../src/baobab-ringschart.vala"
					gtk_render_layout (_tmp87_, cr, _tmp88_.x + _tmp89_.left, _tmp90_.y + _tmp91_.top, _tmp92_);
#line 861 "baobab-ringschart.c"
				}
#line 117 "../src/baobab-ringschart.vala"
				_g_free0 (markup);
#line 117 "../src/baobab-ringschart.vala"
				_g_object_unref0 (layout);
#line 117 "../src/baobab-ringschart.vala"
				_baobab_chart_item_unref0 (ringsitem);
#line 117 "../src/baobab-ringschart.vala"
				_baobab_chart_item_unref0 (item);
#line 871 "baobab-ringschart.c"
			}
		}
	}
#line 221 "../src/baobab-ringschart.vala"
	_tmp93_ = context;
#line 221 "../src/baobab-ringschart.vala"
	gtk_style_context_restore (_tmp93_);
#line 95 "../src/baobab-ringschart.vala"
	_g_object_unref0 (context);
#line 881 "baobab-ringschart.c"
}

static void
baobab_ringschart_real_draw_item (BaobabChart* base,
                                  cairo_t* cr,
                                  BaobabChartItem* item,
                                  gboolean highlighted)
{
	BaobabRingschart * self;
	BaobabRingschartItem* ringsitem = NULL;
	BaobabRingschartItem* _tmp0_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp11_ = {0};
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GdkRGBA border_color = {0};
	GdkRGBA bg_color = {0};
	GtkStyleContext* _tmp14_;
	GdkRGBA _tmp15_ = {0};
	GtkStyleContext* _tmp16_;
	GdkRGBA _tmp17_ = {0};
	gint center_x = 0;
	GtkAllocation _tmp18_;
	gint center_y = 0;
	GtkAllocation _tmp19_;
	gdouble final_angle = 0.0;
	BaobabRingschartItem* _tmp20_;
	BaobabRingschartItem* _tmp21_;
#line 224 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 224 "../src/baobab-ringschart.vala"
	g_return_if_fail (cr != NULL);
#line 224 "../src/baobab-ringschart.vala"
	g_return_if_fail (item != NULL);
#line 225 "../src/baobab-ringschart.vala"
	_tmp0_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (item) ? ((BaobabRingschartItem*) item) : NULL);
#line 225 "../src/baobab-ringschart.vala"
	ringsitem = _tmp0_;
#line 227 "../src/baobab-ringschart.vala"
	if (self->priv->drawing_subtips) {
#line 923 "baobab-ringschart.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		BaobabChartItem* _tmp3_;
		BaobabChartItem* _tmp4_;
#line 228 "../src/baobab-ringschart.vala"
		_tmp3_ = baobab_chart_get_highlighted_item ((BaobabChart*) self);
#line 228 "../src/baobab-ringschart.vala"
		_tmp4_ = _tmp3_;
#line 228 "../src/baobab-ringschart.vala"
		if (_tmp4_ != NULL) {
#line 934 "baobab-ringschart.c"
			GList* _tmp5_;
#line 229 "../src/baobab-ringschart.vala"
			_tmp5_ = item->parent;
#line 229 "../src/baobab-ringschart.vala"
			_tmp2_ = _tmp5_ != NULL;
#line 940 "baobab-ringschart.c"
		} else {
#line 228 "../src/baobab-ringschart.vala"
			_tmp2_ = FALSE;
#line 944 "baobab-ringschart.c"
		}
#line 228 "../src/baobab-ringschart.vala"
		if (_tmp2_) {
#line 948 "baobab-ringschart.c"
			GList* _tmp6_;
			gconstpointer _tmp7_;
			BaobabChartItem* _tmp8_;
			BaobabChartItem* _tmp9_;
#line 230 "../src/baobab-ringschart.vala"
			_tmp6_ = item->parent;
#line 230 "../src/baobab-ringschart.vala"
			_tmp7_ = _tmp6_->data;
#line 230 "../src/baobab-ringschart.vala"
			_tmp8_ = baobab_chart_get_highlighted_item ((BaobabChart*) self);
#line 230 "../src/baobab-ringschart.vala"
			_tmp9_ = _tmp8_;
#line 230 "../src/baobab-ringschart.vala"
			_tmp1_ = ((BaobabChartItem*) _tmp7_) == _tmp9_;
#line 963 "baobab-ringschart.c"
		} else {
#line 228 "../src/baobab-ringschart.vala"
			_tmp1_ = FALSE;
#line 967 "baobab-ringschart.c"
		}
#line 228 "../src/baobab-ringschart.vala"
		if (_tmp1_) {
#line 971 "baobab-ringschart.c"
			BaobabChartItem* _tmp10_;
#line 231 "../src/baobab-ringschart.vala"
			_tmp10_ = _baobab_chart_item_ref0 (item);
#line 231 "../src/baobab-ringschart.vala"
			self->priv->subtip_items = g_list_append (self->priv->subtip_items, _tmp10_);
#line 977 "baobab-ringschart.c"
		}
	}
#line 235 "../src/baobab-ringschart.vala"
	cairo_set_line_width (cr, (gdouble) BAOBAB_RINGSCHART_ITEM_BORDER_WIDTH);
#line 238 "../src/baobab-ringschart.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp11_);
#line 238 "../src/baobab-ringschart.vala"
	allocation = _tmp11_;
#line 240 "../src/baobab-ringschart.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 240 "../src/baobab-ringschart.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 240 "../src/baobab-ringschart.vala"
	context = _tmp13_;
#line 244 "../src/baobab-ringschart.vala"
	_tmp14_ = context;
#line 244 "../src/baobab-ringschart.vala"
	gtk_style_context_lookup_color (_tmp14_, "chart_borders", &_tmp15_);
#line 244 "../src/baobab-ringschart.vala"
	border_color = _tmp15_;
#line 245 "../src/baobab-ringschart.vala"
	_tmp16_ = context;
#line 245 "../src/baobab-ringschart.vala"
	gtk_style_context_lookup_color (_tmp16_, "theme_bg_color", &_tmp17_);
#line 245 "../src/baobab-ringschart.vala"
	bg_color = _tmp17_;
#line 247 "../src/baobab-ringschart.vala"
	_tmp18_ = allocation;
#line 247 "../src/baobab-ringschart.vala"
	center_x = _tmp18_.width / 2;
#line 248 "../src/baobab-ringschart.vala"
	_tmp19_ = allocation;
#line 248 "../src/baobab-ringschart.vala"
	center_y = _tmp19_.height / 2;
#line 249 "../src/baobab-ringschart.vala"
	_tmp20_ = ringsitem;
#line 249 "../src/baobab-ringschart.vala"
	_tmp21_ = ringsitem;
#line 249 "../src/baobab-ringschart.vala"
	final_angle = _tmp20_->start_angle + _tmp21_->angle;
#line 251 "../src/baobab-ringschart.vala"
	if (item->depth == ((guint) 0)) {
#line 1020 "baobab-ringschart.c"
		PangoLayout* layout = NULL;
		PangoLayout* _tmp22_;
		gchar* size = NULL;
		BaobabScannerResults* _tmp23_;
		guint64 _tmp24_;
		guint64 _tmp25_;
		gchar* _tmp26_;
		gchar* markup = NULL;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		PangoLayout* _tmp34_;
		const gchar* _tmp35_;
		PangoLayout* _tmp36_;
		PangoLayout* _tmp37_;
		PangoRectangle layout_rect = {0};
		PangoLayout* _tmp38_;
		PangoRectangle _tmp39_ = {0};
		PangoRectangle _tmp40_;
		BaobabRingschartItem* _tmp41_;
		BaobabRingschartItem* _tmp47_;
		GdkRGBA _tmp48_;
#line 254 "../src/baobab-ringschart.vala"
		_tmp22_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
#line 254 "../src/baobab-ringschart.vala"
		layout = _tmp22_;
#line 255 "../src/baobab-ringschart.vala"
		_tmp23_ = item->results;
#line 255 "../src/baobab-ringschart.vala"
		_tmp24_ = baobab_scanner_results_get_size (_tmp23_);
#line 255 "../src/baobab-ringschart.vala"
		_tmp25_ = _tmp24_;
#line 255 "../src/baobab-ringschart.vala"
		_tmp26_ = g_format_size_full (_tmp25_, G_FORMAT_SIZE_DEFAULT);
#line 255 "../src/baobab-ringschart.vala"
		size = _tmp26_;
#line 256 "../src/baobab-ringschart.vala"
		_tmp27_ = size;
#line 256 "../src/baobab-ringschart.vala"
		_tmp28_ = g_markup_escape_text (_tmp27_, (gssize) -1);
#line 256 "../src/baobab-ringschart.vala"
		_tmp29_ = _tmp28_;
#line 256 "../src/baobab-ringschart.vala"
		_tmp30_ = g_strconcat ("<span size=\"small\">", _tmp29_, NULL);
#line 256 "../src/baobab-ringschart.vala"
		_tmp31_ = _tmp30_;
#line 256 "../src/baobab-ringschart.vala"
		_tmp32_ = g_strconcat (_tmp31_, "</span>", NULL);
#line 256 "../src/baobab-ringschart.vala"
		_tmp33_ = _tmp32_;
#line 256 "../src/baobab-ringschart.vala"
		_g_free0 (_tmp31_);
#line 256 "../src/baobab-ringschart.vala"
		_g_free0 (_tmp29_);
#line 256 "../src/baobab-ringschart.vala"
		markup = _tmp33_;
#line 257 "../src/baobab-ringschart.vala"
		_tmp34_ = layout;
#line 257 "../src/baobab-ringschart.vala"
		_tmp35_ = markup;
#line 257 "../src/baobab-ringschart.vala"
		pango_layout_set_markup (_tmp34_, _tmp35_, -1);
#line 258 "../src/baobab-ringschart.vala"
		_tmp36_ = layout;
#line 258 "../src/baobab-ringschart.vala"
		pango_layout_set_indent (_tmp36_, 0);
#line 259 "../src/baobab-ringschart.vala"
		_tmp37_ = layout;
#line 259 "../src/baobab-ringschart.vala"
		pango_layout_set_spacing (_tmp37_, 0);
#line 261 "../src/baobab-ringschart.vala"
		_tmp38_ = layout;
#line 261 "../src/baobab-ringschart.vala"
		pango_layout_get_pixel_extents (_tmp38_, NULL, &_tmp39_);
#line 261 "../src/baobab-ringschart.vala"
		layout_rect = _tmp39_;
#line 263 "../src/baobab-ringschart.vala"
		_tmp40_ = layout_rect;
#line 263 "../src/baobab-ringschart.vala"
		_tmp41_ = ringsitem;
#line 263 "../src/baobab-ringschart.vala"
		if (((gdouble) _tmp40_.width) < (2 * _tmp41_->max_radius)) {
#line 1107 "baobab-ringschart.c"
			GtkStyleContext* _tmp42_;
			PangoRectangle _tmp43_;
			PangoRectangle _tmp44_;
			PangoLayout* _tmp45_;
			BaobabRingschartItem* _tmp46_;
#line 264 "../src/baobab-ringschart.vala"
			_tmp42_ = context;
#line 264 "../src/baobab-ringschart.vala"
			_tmp43_ = layout_rect;
#line 264 "../src/baobab-ringschart.vala"
			_tmp44_ = layout_rect;
#line 264 "../src/baobab-ringschart.vala"
			_tmp45_ = layout;
#line 264 "../src/baobab-ringschart.vala"
			gtk_render_layout (_tmp42_, cr, (gdouble) (center_x - (_tmp43_.width / 2)), (gdouble) (center_y - (_tmp44_.height / 2)), _tmp45_);
#line 265 "../src/baobab-ringschart.vala"
			_tmp46_ = ringsitem;
#line 265 "../src/baobab-ringschart.vala"
			cairo_move_to (cr, (center_x + _tmp46_->max_radius) + 1, (gdouble) center_y);
#line 1127 "baobab-ringschart.c"
		}
#line 268 "../src/baobab-ringschart.vala"
		_tmp47_ = ringsitem;
#line 268 "../src/baobab-ringschart.vala"
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, _tmp47_->max_radius + 1, (gdouble) 0, 2 * G_PI);
#line 269 "../src/baobab-ringschart.vala"
		_tmp48_ = border_color;
#line 269 "../src/baobab-ringschart.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp48_);
#line 270 "../src/baobab-ringschart.vala"
		cairo_stroke (cr);
#line 251 "../src/baobab-ringschart.vala"
		_g_free0 (markup);
#line 251 "../src/baobab-ringschart.vala"
		_g_free0 (size);
#line 251 "../src/baobab-ringschart.vala"
		_g_object_unref0 (layout);
#line 1145 "baobab-ringschart.c"
	} else {
		GdkRGBA fill_color = {0};
		BaobabRingschartItem* _tmp49_;
		GdkRGBA _tmp50_ = {0};
		BaobabRingschartItem* _tmp51_;
		BaobabRingschartItem* _tmp52_;
		BaobabRingschartItem* _tmp53_;
		BaobabRingschartItem* _tmp54_;
		GdkRGBA _tmp55_;
		GdkRGBA _tmp56_;
		BaobabRingschartItem* _tmp57_;
#line 272 "../src/baobab-ringschart.vala"
		_tmp49_ = ringsitem;
#line 272 "../src/baobab-ringschart.vala"
		baobab_chart_get_item_color ((BaobabChart*) self, (_tmp49_->start_angle / G_PI) * 99, item->depth, highlighted, &_tmp50_);
#line 272 "../src/baobab-ringschart.vala"
		fill_color = _tmp50_;
#line 276 "../src/baobab-ringschart.vala"
		_tmp51_ = ringsitem;
#line 276 "../src/baobab-ringschart.vala"
		_tmp52_ = ringsitem;
#line 276 "../src/baobab-ringschart.vala"
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, _tmp51_->min_radius, _tmp52_->start_angle, final_angle);
#line 277 "../src/baobab-ringschart.vala"
		_tmp53_ = ringsitem;
#line 277 "../src/baobab-ringschart.vala"
		_tmp54_ = ringsitem;
#line 277 "../src/baobab-ringschart.vala"
		cairo_arc_negative (cr, (gdouble) center_x, (gdouble) center_y, _tmp53_->max_radius, final_angle, _tmp54_->start_angle);
#line 279 "../src/baobab-ringschart.vala"
		cairo_close_path (cr);
#line 281 "../src/baobab-ringschart.vala"
		_tmp55_ = fill_color;
#line 281 "../src/baobab-ringschart.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp55_);
#line 282 "../src/baobab-ringschart.vala"
		cairo_fill_preserve (cr);
#line 283 "../src/baobab-ringschart.vala"
		_tmp56_ = bg_color;
#line 283 "../src/baobab-ringschart.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp56_);
#line 284 "../src/baobab-ringschart.vala"
		cairo_stroke (cr);
#line 286 "../src/baobab-ringschart.vala"
		_tmp57_ = ringsitem;
#line 286 "../src/baobab-ringschart.vala"
		if (_tmp57_->continued) {
#line 1193 "baobab-ringschart.c"
			GdkRGBA _tmp58_;
			BaobabRingschartItem* _tmp59_;
			BaobabRingschartItem* _tmp60_;
#line 287 "../src/baobab-ringschart.vala"
			_tmp58_ = border_color;
#line 287 "../src/baobab-ringschart.vala"
			gdk_cairo_set_source_rgba (cr, &_tmp58_);
#line 288 "../src/baobab-ringschart.vala"
			cairo_set_line_width (cr, (gdouble) 3);
#line 289 "../src/baobab-ringschart.vala"
			_tmp59_ = ringsitem;
#line 289 "../src/baobab-ringschart.vala"
			_tmp60_ = ringsitem;
#line 289 "../src/baobab-ringschart.vala"
			cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, _tmp59_->max_radius + 4, _tmp60_->start_angle + BAOBAB_RINGSCHART_EDGE_ANGLE, final_angle - BAOBAB_RINGSCHART_EDGE_ANGLE);
#line 290 "../src/baobab-ringschart.vala"
			cairo_stroke (cr);
#line 1211 "baobab-ringschart.c"
		}
	}
#line 224 "../src/baobab-ringschart.vala"
	_g_object_unref0 (context);
#line 224 "../src/baobab-ringschart.vala"
	_baobab_chart_item_unref0 (ringsitem);
#line 1218 "baobab-ringschart.c"
}

static void
baobab_ringschart_real_calculate_item_geometry (BaobabChart* base,
                                                BaobabChartItem* item)
{
	BaobabRingschart * self;
	BaobabRingschartItem* ringsitem = NULL;
	BaobabRingschartItem* _tmp0_;
	BaobabRingschartItem* _tmp1_;
	BaobabRingschartItem* _tmp2_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp3_ = {0};
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp6_;
	GtkBorder _tmp7_ = {0};
	gint max_radius = 0;
	GtkAllocation _tmp8_;
	GtkAllocation _tmp9_;
	GtkBorder _tmp10_;
	guint thickness = 0U;
	guint _tmp11_;
	guint _tmp12_;
	BaobabRingschartItem* _tmp13_;
	GList* _tmp14_;
	BaobabRingschartItem* _tmp48_;
#line 295 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 295 "../src/baobab-ringschart.vala"
	g_return_if_fail (item != NULL);
#line 296 "../src/baobab-ringschart.vala"
	_tmp0_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (item) ? ((BaobabRingschartItem*) item) : NULL);
#line 296 "../src/baobab-ringschart.vala"
	ringsitem = _tmp0_;
#line 298 "../src/baobab-ringschart.vala"
	_tmp1_ = ringsitem;
#line 298 "../src/baobab-ringschart.vala"
	_tmp1_->continued = FALSE;
#line 299 "../src/baobab-ringschart.vala"
	_tmp2_ = ringsitem;
#line 299 "../src/baobab-ringschart.vala"
	((BaobabChartItem*) _tmp2_)->visible = FALSE;
#line 302 "../src/baobab-ringschart.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
#line 302 "../src/baobab-ringschart.vala"
	allocation = _tmp3_;
#line 304 "../src/baobab-ringschart.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 304 "../src/baobab-ringschart.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 304 "../src/baobab-ringschart.vala"
	context = _tmp5_;
#line 305 "../src/baobab-ringschart.vala"
	_tmp6_ = context;
#line 305 "../src/baobab-ringschart.vala"
	gtk_style_context_get_padding (_tmp6_, &_tmp7_);
#line 305 "../src/baobab-ringschart.vala"
	padding = _tmp7_;
#line 306 "../src/baobab-ringschart.vala"
	_tmp8_ = allocation;
#line 306 "../src/baobab-ringschart.vala"
	_tmp9_ = allocation;
#line 306 "../src/baobab-ringschart.vala"
	_tmp10_ = padding;
#line 306 "../src/baobab-ringschart.vala"
	max_radius = MIN (_tmp8_.width / 2, _tmp9_.height / 2) - _tmp10_.left;
#line 307 "../src/baobab-ringschart.vala"
	_tmp11_ = baobab_chart_get_max_depth ((BaobabChart*) self);
#line 307 "../src/baobab-ringschart.vala"
	_tmp12_ = _tmp11_;
#line 307 "../src/baobab-ringschart.vala"
	thickness = max_radius / (_tmp12_ + 1);
#line 309 "../src/baobab-ringschart.vala"
	_tmp13_ = ringsitem;
#line 309 "../src/baobab-ringschart.vala"
	_tmp14_ = ((BaobabChartItem*) _tmp13_)->parent;
#line 309 "../src/baobab-ringschart.vala"
	if (_tmp14_ == NULL) {
#line 1300 "baobab-ringschart.c"
		BaobabRingschartItem* _tmp15_;
		BaobabRingschartItem* _tmp16_;
		BaobabRingschartItem* _tmp17_;
		BaobabRingschartItem* _tmp18_;
#line 310 "../src/baobab-ringschart.vala"
		_tmp15_ = ringsitem;
#line 310 "../src/baobab-ringschart.vala"
		_tmp15_->min_radius = (gdouble) 0;
#line 311 "../src/baobab-ringschart.vala"
		_tmp16_ = ringsitem;
#line 311 "../src/baobab-ringschart.vala"
		_tmp16_->max_radius = (gdouble) thickness;
#line 312 "../src/baobab-ringschart.vala"
		_tmp17_ = ringsitem;
#line 312 "../src/baobab-ringschart.vala"
		_tmp17_->start_angle = (gdouble) 0;
#line 313 "../src/baobab-ringschart.vala"
		_tmp18_ = ringsitem;
#line 313 "../src/baobab-ringschart.vala"
		_tmp18_->angle = 2 * G_PI;
#line 1321 "baobab-ringschart.c"
	} else {
		BaobabRingschartItem* parent = NULL;
		GList* _tmp19_;
		gconstpointer _tmp20_;
		BaobabChartItem* _tmp21_;
		BaobabRingschartItem* _tmp22_;
		BaobabRingschartItem* _tmp23_;
		BaobabRingschartItem* _tmp24_;
		BaobabRingschartItem* _tmp25_;
		guint _tmp26_;
		guint _tmp27_;
		BaobabRingschartItem* _tmp30_;
		BaobabRingschartItem* _tmp31_;
		BaobabRingschartItem* _tmp32_;
		BaobabRingschartItem* _tmp33_;
		BaobabRingschartItem* _tmp34_;
		BaobabRingschartItem* _tmp35_;
		BaobabRingschartItem* _tmp36_;
		BaobabRingschartItem* _tmp37_;
		gboolean _tmp38_ = FALSE;
		BaobabRingschartItem* _tmp39_;
		BaobabScannerResults* _tmp40_;
		gboolean _tmp41_;
		gboolean _tmp42_;
		BaobabRingschartItem* _tmp46_;
		BaobabRingschartItem* _tmp47_;
#line 315 "../src/baobab-ringschart.vala"
		_tmp19_ = item->parent;
#line 315 "../src/baobab-ringschart.vala"
		_tmp20_ = _tmp19_->data;
#line 315 "../src/baobab-ringschart.vala"
		_tmp21_ = (BaobabChartItem*) _tmp20_;
#line 315 "../src/baobab-ringschart.vala"
		_tmp22_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (_tmp21_) ? ((BaobabRingschartItem*) _tmp21_) : NULL);
#line 315 "../src/baobab-ringschart.vala"
		parent = _tmp22_;
#line 316 "../src/baobab-ringschart.vala"
		_tmp23_ = ringsitem;
#line 316 "../src/baobab-ringschart.vala"
		_tmp24_ = ringsitem;
#line 316 "../src/baobab-ringschart.vala"
		_tmp23_->min_radius = (gdouble) (((BaobabChartItem*) _tmp24_)->depth * thickness);
#line 317 "../src/baobab-ringschart.vala"
		_tmp25_ = ringsitem;
#line 317 "../src/baobab-ringschart.vala"
		_tmp26_ = baobab_chart_get_max_depth ((BaobabChart*) self);
#line 317 "../src/baobab-ringschart.vala"
		_tmp27_ = _tmp26_;
#line 317 "../src/baobab-ringschart.vala"
		if (((BaobabChartItem*) _tmp25_)->depth > _tmp27_) {
#line 318 "../src/baobab-ringschart.vala"
			_baobab_chart_item_unref0 (parent);
#line 318 "../src/baobab-ringschart.vala"
			_g_object_unref0 (context);
#line 318 "../src/baobab-ringschart.vala"
			_baobab_chart_item_unref0 (ringsitem);
#line 318 "../src/baobab-ringschart.vala"
			return;
#line 1380 "baobab-ringschart.c"
		} else {
			BaobabRingschartItem* _tmp28_;
			BaobabRingschartItem* _tmp29_;
#line 320 "../src/baobab-ringschart.vala"
			_tmp28_ = ringsitem;
#line 320 "../src/baobab-ringschart.vala"
			_tmp29_ = ringsitem;
#line 320 "../src/baobab-ringschart.vala"
			_tmp28_->max_radius = _tmp29_->min_radius + thickness;
#line 1390 "baobab-ringschart.c"
		}
#line 323 "../src/baobab-ringschart.vala"
		_tmp30_ = ringsitem;
#line 323 "../src/baobab-ringschart.vala"
		_tmp31_ = parent;
#line 323 "../src/baobab-ringschart.vala"
		_tmp32_ = ringsitem;
#line 323 "../src/baobab-ringschart.vala"
		_tmp30_->angle = (_tmp31_->angle * ((BaobabChartItem*) _tmp32_)->rel_size) / 100;
#line 324 "../src/baobab-ringschart.vala"
		_tmp33_ = ringsitem;
#line 324 "../src/baobab-ringschart.vala"
		if (_tmp33_->angle < BAOBAB_RINGSCHART_ITEM_MIN_ANGLE) {
#line 325 "../src/baobab-ringschart.vala"
			_baobab_chart_item_unref0 (parent);
#line 325 "../src/baobab-ringschart.vala"
			_g_object_unref0 (context);
#line 325 "../src/baobab-ringschart.vala"
			_baobab_chart_item_unref0 (ringsitem);
#line 325 "../src/baobab-ringschart.vala"
			return;
#line 1412 "baobab-ringschart.c"
		}
#line 328 "../src/baobab-ringschart.vala"
		_tmp34_ = ringsitem;
#line 328 "../src/baobab-ringschart.vala"
		_tmp35_ = parent;
#line 328 "../src/baobab-ringschart.vala"
		_tmp36_ = parent;
#line 328 "../src/baobab-ringschart.vala"
		_tmp37_ = ringsitem;
#line 328 "../src/baobab-ringschart.vala"
		_tmp34_->start_angle = _tmp35_->start_angle + ((_tmp36_->angle * ((BaobabChartItem*) _tmp37_)->rel_start) / 100);
#line 329 "../src/baobab-ringschart.vala"
		_tmp39_ = ringsitem;
#line 329 "../src/baobab-ringschart.vala"
		_tmp40_ = ((BaobabChartItem*) _tmp39_)->results;
#line 329 "../src/baobab-ringschart.vala"
		_tmp41_ = baobab_scanner_results_get_is_empty (_tmp40_);
#line 329 "../src/baobab-ringschart.vala"
		_tmp42_ = _tmp41_;
#line 329 "../src/baobab-ringschart.vala"
		if (!_tmp42_) {
#line 1434 "baobab-ringschart.c"
			BaobabRingschartItem* _tmp43_;
			guint _tmp44_;
			guint _tmp45_;
#line 329 "../src/baobab-ringschart.vala"
			_tmp43_ = ringsitem;
#line 329 "../src/baobab-ringschart.vala"
			_tmp44_ = baobab_chart_get_max_depth ((BaobabChart*) self);
#line 329 "../src/baobab-ringschart.vala"
			_tmp45_ = _tmp44_;
#line 329 "../src/baobab-ringschart.vala"
			_tmp38_ = ((BaobabChartItem*) _tmp43_)->depth == _tmp45_;
#line 1446 "baobab-ringschart.c"
		} else {
#line 329 "../src/baobab-ringschart.vala"
			_tmp38_ = FALSE;
#line 1450 "baobab-ringschart.c"
		}
#line 329 "../src/baobab-ringschart.vala"
		_tmp46_ = ringsitem;
#line 329 "../src/baobab-ringschart.vala"
		_tmp46_->continued = _tmp38_;
#line 330 "../src/baobab-ringschart.vala"
		_tmp47_ = parent;
#line 330 "../src/baobab-ringschart.vala"
		((BaobabChartItem*) _tmp47_)->has_visible_children = TRUE;
#line 309 "../src/baobab-ringschart.vala"
		_baobab_chart_item_unref0 (parent);
#line 1462 "baobab-ringschart.c"
	}
#line 333 "../src/baobab-ringschart.vala"
	_tmp48_ = ringsitem;
#line 333 "../src/baobab-ringschart.vala"
	((BaobabChartItem*) _tmp48_)->visible = TRUE;
#line 334 "../src/baobab-ringschart.vala"
	baobab_chart_get_item_rectangle ((BaobabChart*) self, item);
#line 295 "../src/baobab-ringschart.vala"
	_g_object_unref0 (context);
#line 295 "../src/baobab-ringschart.vala"
	_baobab_chart_item_unref0 (ringsitem);
#line 1474 "baobab-ringschart.c"
}

static void
baobab_ringschart_get_point_min_rect (BaobabRingschart* self,
                                      gdouble cx,
                                      gdouble cy,
                                      gdouble radius,
                                      gdouble angle,
                                      GdkRectangle* r)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
#line 337 "../src/baobab-ringschart.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/baobab-ringschart.vala"
	g_return_if_fail (r != NULL);
#line 339 "../src/baobab-ringschart.vala"
	x = cx + (cos (angle) * radius);
#line 340 "../src/baobab-ringschart.vala"
	y = cy + (sin (angle) * radius);
#line 342 "../src/baobab-ringschart.vala"
	_tmp0_ = *r;
#line 342 "../src/baobab-ringschart.vala"
	(*r).x = MIN (_tmp0_.x, (gint) x);
#line 343 "../src/baobab-ringschart.vala"
	_tmp1_ = *r;
#line 343 "../src/baobab-ringschart.vala"
	(*r).y = MIN (_tmp1_.y, (gint) y);
#line 344 "../src/baobab-ringschart.vala"
	_tmp2_ = *r;
#line 344 "../src/baobab-ringschart.vala"
	(*r).width = MAX (_tmp2_.width, (gint) x);
#line 345 "../src/baobab-ringschart.vala"
	_tmp3_ = *r;
#line 345 "../src/baobab-ringschart.vala"
	(*r).height = MAX (_tmp3_.height, (gint) y);
#line 1515 "baobab-ringschart.c"
}

static void
baobab_ringschart_real_get_item_rectangle (BaobabChart* base,
                                           BaobabChartItem* item)
{
	BaobabRingschart * self;
	BaobabRingschartItem* ringsitem = NULL;
	BaobabRingschartItem* _tmp0_;
	GdkRectangle rect = {0};
	gdouble cx = 0.0;
	gdouble cy = 0.0;
	gdouble r1 = 0.0;
	gdouble r2 = 0.0;
	gdouble a1 = 0.0;
	gdouble a2 = 0.0;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp1_ = {0};
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	BaobabRingschartItem* _tmp4_;
	BaobabRingschartItem* _tmp5_;
	BaobabRingschartItem* _tmp6_;
	BaobabRingschartItem* _tmp7_;
	BaobabRingschartItem* _tmp8_;
	GtkAllocation _tmp9_;
	GtkAllocation _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp17_ = FALSE;
	GdkRectangle _tmp19_;
	GdkRectangle _tmp20_;
	BaobabRingschartItem* _tmp21_;
	GdkRectangle _tmp22_;
#line 348 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 348 "../src/baobab-ringschart.vala"
	g_return_if_fail (item != NULL);
#line 349 "../src/baobab-ringschart.vala"
	_tmp0_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (item) ? ((BaobabRingschartItem*) item) : NULL);
#line 349 "../src/baobab-ringschart.vala"
	ringsitem = _tmp0_;
#line 350 "../src/baobab-ringschart.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 354 "../src/baobab-ringschart.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
#line 354 "../src/baobab-ringschart.vala"
	allocation = _tmp1_;
#line 355 "../src/baobab-ringschart.vala"
	_tmp2_ = allocation;
#line 355 "../src/baobab-ringschart.vala"
	cx = (gdouble) (_tmp2_.width / 2);
#line 356 "../src/baobab-ringschart.vala"
	_tmp3_ = allocation;
#line 356 "../src/baobab-ringschart.vala"
	cy = (gdouble) (_tmp3_.height / 2);
#line 357 "../src/baobab-ringschart.vala"
	_tmp4_ = ringsitem;
#line 357 "../src/baobab-ringschart.vala"
	r1 = _tmp4_->min_radius;
#line 358 "../src/baobab-ringschart.vala"
	_tmp5_ = ringsitem;
#line 358 "../src/baobab-ringschart.vala"
	r2 = _tmp5_->max_radius;
#line 359 "../src/baobab-ringschart.vala"
	_tmp6_ = ringsitem;
#line 359 "../src/baobab-ringschart.vala"
	a1 = _tmp6_->start_angle;
#line 360 "../src/baobab-ringschart.vala"
	_tmp7_ = ringsitem;
#line 360 "../src/baobab-ringschart.vala"
	_tmp8_ = ringsitem;
#line 360 "../src/baobab-ringschart.vala"
	a2 = _tmp7_->start_angle + _tmp8_->angle;
#line 362 "../src/baobab-ringschart.vala"
	_tmp9_ = allocation;
#line 362 "../src/baobab-ringschart.vala"
	rect.x = _tmp9_.width;
#line 363 "../src/baobab-ringschart.vala"
	_tmp10_ = allocation;
#line 363 "../src/baobab-ringschart.vala"
	rect.y = _tmp10_.height;
#line 364 "../src/baobab-ringschart.vala"
	rect.width = 0;
#line 365 "../src/baobab-ringschart.vala"
	rect.height = 0;
#line 367 "../src/baobab-ringschart.vala"
	baobab_ringschart_get_point_min_rect (self, cx, cy, r1, a1, &rect);
#line 368 "../src/baobab-ringschart.vala"
	baobab_ringschart_get_point_min_rect (self, cx, cy, r2, a1, &rect);
#line 369 "../src/baobab-ringschart.vala"
	baobab_ringschart_get_point_min_rect (self, cx, cy, r1, a2, &rect);
#line 370 "../src/baobab-ringschart.vala"
	baobab_ringschart_get_point_min_rect (self, cx, cy, r2, a2, &rect);
#line 372 "../src/baobab-ringschart.vala"
	if (a1 <= (G_PI / 2)) {
#line 372 "../src/baobab-ringschart.vala"
		_tmp11_ = a2 >= (G_PI / 2);
#line 1615 "baobab-ringschart.c"
	} else {
#line 372 "../src/baobab-ringschart.vala"
		_tmp11_ = FALSE;
#line 1619 "baobab-ringschart.c"
	}
#line 372 "../src/baobab-ringschart.vala"
	if (_tmp11_) {
#line 1623 "baobab-ringschart.c"
		GdkRectangle _tmp12_;
#line 373 "../src/baobab-ringschart.vala"
		_tmp12_ = rect;
#line 373 "../src/baobab-ringschart.vala"
		rect.height = (gint) MAX ((gdouble) _tmp12_.height, cy + (sin (G_PI / 2) * r2));
#line 1629 "baobab-ringschart.c"
	}
#line 376 "../src/baobab-ringschart.vala"
	if (a1 <= G_PI) {
#line 376 "../src/baobab-ringschart.vala"
		_tmp13_ = a2 >= G_PI;
#line 1635 "baobab-ringschart.c"
	} else {
#line 376 "../src/baobab-ringschart.vala"
		_tmp13_ = FALSE;
#line 1639 "baobab-ringschart.c"
	}
#line 376 "../src/baobab-ringschart.vala"
	if (_tmp13_) {
#line 1643 "baobab-ringschart.c"
		GdkRectangle _tmp14_;
#line 377 "../src/baobab-ringschart.vala"
		_tmp14_ = rect;
#line 377 "../src/baobab-ringschart.vala"
		rect.x = (gint) MIN ((gdouble) _tmp14_.x, cx + (cos (G_PI) * r2));
#line 1649 "baobab-ringschart.c"
	}
#line 380 "../src/baobab-ringschart.vala"
	if (a1 <= (G_PI * 1.5)) {
#line 380 "../src/baobab-ringschart.vala"
		_tmp15_ = a2 >= (G_PI * 1.5);
#line 1655 "baobab-ringschart.c"
	} else {
#line 380 "../src/baobab-ringschart.vala"
		_tmp15_ = FALSE;
#line 1659 "baobab-ringschart.c"
	}
#line 380 "../src/baobab-ringschart.vala"
	if (_tmp15_) {
#line 1663 "baobab-ringschart.c"
		GdkRectangle _tmp16_;
#line 381 "../src/baobab-ringschart.vala"
		_tmp16_ = rect;
#line 381 "../src/baobab-ringschart.vala"
		rect.y = (gint) MIN ((gdouble) _tmp16_.y, cy + (sin (G_PI * 1.5) * r2));
#line 1669 "baobab-ringschart.c"
	}
#line 384 "../src/baobab-ringschart.vala"
	if (a1 <= (G_PI * 2)) {
#line 384 "../src/baobab-ringschart.vala"
		_tmp17_ = a2 >= (G_PI * 2);
#line 1675 "baobab-ringschart.c"
	} else {
#line 384 "../src/baobab-ringschart.vala"
		_tmp17_ = FALSE;
#line 1679 "baobab-ringschart.c"
	}
#line 384 "../src/baobab-ringschart.vala"
	if (_tmp17_) {
#line 1683 "baobab-ringschart.c"
		GdkRectangle _tmp18_;
#line 385 "../src/baobab-ringschart.vala"
		_tmp18_ = rect;
#line 385 "../src/baobab-ringschart.vala"
		rect.width = (gint) MAX ((gdouble) _tmp18_.width, cx + (cos (G_PI * 2) * r2));
#line 1689 "baobab-ringschart.c"
	}
#line 388 "../src/baobab-ringschart.vala"
	_tmp19_ = rect;
#line 388 "../src/baobab-ringschart.vala"
	rect.width = rect.width - _tmp19_.x;
#line 389 "../src/baobab-ringschart.vala"
	_tmp20_ = rect;
#line 389 "../src/baobab-ringschart.vala"
	rect.height = rect.height - _tmp20_.y;
#line 391 "../src/baobab-ringschart.vala"
	_tmp21_ = ringsitem;
#line 391 "../src/baobab-ringschart.vala"
	_tmp22_ = rect;
#line 391 "../src/baobab-ringschart.vala"
	((BaobabChartItem*) _tmp21_)->rect = _tmp22_;
#line 348 "../src/baobab-ringschart.vala"
	_baobab_chart_item_unref0 (ringsitem);
#line 1707 "baobab-ringschart.c"
}

static gboolean
baobab_ringschart_real_is_point_over_item (BaobabChart* base,
                                           BaobabChartItem* item,
                                           gdouble x,
                                           gdouble y)
{
	BaobabRingschart * self;
	BaobabRingschartItem* ringsitem = NULL;
	BaobabRingschartItem* _tmp0_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp1_ = {0};
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	gdouble radius = 0.0;
	gdouble angle = 0.0;
	gdouble _tmp4_ = 0.0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	BaobabRingschartItem* _tmp8_;
	gboolean result;
#line 394 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 394 "../src/baobab-ringschart.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 395 "../src/baobab-ringschart.vala"
	_tmp0_ = _baobab_chart_item_ref0 (BAOBAB_IS_RINGSCHART_ITEM (item) ? ((BaobabRingschartItem*) item) : NULL);
#line 395 "../src/baobab-ringschart.vala"
	ringsitem = _tmp0_;
#line 398 "../src/baobab-ringschart.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
#line 398 "../src/baobab-ringschart.vala"
	allocation = _tmp1_;
#line 400 "../src/baobab-ringschart.vala"
	_tmp2_ = allocation;
#line 400 "../src/baobab-ringschart.vala"
	x = x - (_tmp2_.width / 2);
#line 401 "../src/baobab-ringschart.vala"
	_tmp3_ = allocation;
#line 401 "../src/baobab-ringschart.vala"
	y = y - (_tmp3_.height / 2);
#line 403 "../src/baobab-ringschart.vala"
	radius = sqrt ((x * x) + (y * y));
#line 404 "../src/baobab-ringschart.vala"
	angle = atan2 (y, x);
#line 405 "../src/baobab-ringschart.vala"
	if (angle > ((gdouble) 0)) {
#line 405 "../src/baobab-ringschart.vala"
		_tmp4_ = angle;
#line 1759 "baobab-ringschart.c"
	} else {
#line 405 "../src/baobab-ringschart.vala"
		_tmp4_ = angle + (2 * G_PI);
#line 1763 "baobab-ringschart.c"
	}
#line 405 "../src/baobab-ringschart.vala"
	angle = _tmp4_;
#line 407 "../src/baobab-ringschart.vala"
	_tmp8_ = ringsitem;
#line 407 "../src/baobab-ringschart.vala"
	if (radius >= _tmp8_->min_radius) {
#line 1771 "baobab-ringschart.c"
		BaobabRingschartItem* _tmp9_;
#line 408 "../src/baobab-ringschart.vala"
		_tmp9_ = ringsitem;
#line 408 "../src/baobab-ringschart.vala"
		_tmp7_ = radius <= _tmp9_->max_radius;
#line 1777 "baobab-ringschart.c"
	} else {
#line 407 "../src/baobab-ringschart.vala"
		_tmp7_ = FALSE;
#line 1781 "baobab-ringschart.c"
	}
#line 407 "../src/baobab-ringschart.vala"
	if (_tmp7_) {
#line 1785 "baobab-ringschart.c"
		BaobabRingschartItem* _tmp10_;
#line 409 "../src/baobab-ringschart.vala"
		_tmp10_ = ringsitem;
#line 409 "../src/baobab-ringschart.vala"
		_tmp6_ = angle >= _tmp10_->start_angle;
#line 1791 "baobab-ringschart.c"
	} else {
#line 407 "../src/baobab-ringschart.vala"
		_tmp6_ = FALSE;
#line 1795 "baobab-ringschart.c"
	}
#line 407 "../src/baobab-ringschart.vala"
	if (_tmp6_) {
#line 1799 "baobab-ringschart.c"
		BaobabRingschartItem* _tmp11_;
		BaobabRingschartItem* _tmp12_;
#line 410 "../src/baobab-ringschart.vala"
		_tmp11_ = ringsitem;
#line 410 "../src/baobab-ringschart.vala"
		_tmp12_ = ringsitem;
#line 410 "../src/baobab-ringschart.vala"
		_tmp5_ = angle <= (_tmp11_->start_angle + _tmp12_->angle);
#line 1808 "baobab-ringschart.c"
	} else {
#line 407 "../src/baobab-ringschart.vala"
		_tmp5_ = FALSE;
#line 1812 "baobab-ringschart.c"
	}
#line 407 "../src/baobab-ringschart.vala"
	result = _tmp5_;
#line 407 "../src/baobab-ringschart.vala"
	_baobab_chart_item_unref0 (ringsitem);
#line 407 "../src/baobab-ringschart.vala"
	return result;
#line 1820 "baobab-ringschart.c"
}

static gboolean
baobab_ringschart_real_can_zoom_out (BaobabChart* base)
{
	BaobabRingschart * self;
	guint _tmp0_;
	guint _tmp1_;
	gboolean result;
#line 413 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 414 "../src/baobab-ringschart.vala"
	_tmp0_ = baobab_chart_get_max_depth ((BaobabChart*) self);
#line 414 "../src/baobab-ringschart.vala"
	_tmp1_ = _tmp0_;
#line 414 "../src/baobab-ringschart.vala"
	result = _tmp1_ < BAOBAB_CHART_MAX_DEPTH;
#line 414 "../src/baobab-ringschart.vala"
	return result;
#line 1840 "baobab-ringschart.c"
}

static gboolean
baobab_ringschart_real_can_zoom_in (BaobabChart* base)
{
	BaobabRingschart * self;
	guint _tmp0_;
	guint _tmp1_;
	gboolean result;
#line 417 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) base;
#line 418 "../src/baobab-ringschart.vala"
	_tmp0_ = baobab_chart_get_max_depth ((BaobabChart*) self);
#line 418 "../src/baobab-ringschart.vala"
	_tmp1_ = _tmp0_;
#line 418 "../src/baobab-ringschart.vala"
	result = _tmp1_ > BAOBAB_CHART_MIN_DEPTH;
#line 418 "../src/baobab-ringschart.vala"
	return result;
#line 1860 "baobab-ringschart.c"
}

BaobabRingschart*
baobab_ringschart_construct (GType object_type)
{
	BaobabRingschart * self = NULL;
#line 45 "../src/baobab-ringschart.vala"
	self = (BaobabRingschart*) baobab_chart_construct (object_type);
#line 45 "../src/baobab-ringschart.vala"
	return self;
#line 1871 "baobab-ringschart.c"
}

BaobabRingschart*
baobab_ringschart_new (void)
{
#line 45 "../src/baobab-ringschart.vala"
	return baobab_ringschart_construct (BAOBAB_TYPE_RINGSCHART);
#line 1879 "baobab-ringschart.c"
}

static void
_baobab_ringschart_subtips_update_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 86 "../src/baobab-ringschart.vala"
	baobab_ringschart_subtips_update ((BaobabRingschart*) self);
#line 1889 "baobab-ringschart.c"
}

static GObject *
baobab_ringschart_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BaobabRingschart * self;
#line 85 "../src/baobab-ringschart.vala"
	parent_class = G_OBJECT_CLASS (baobab_ringschart_parent_class);
#line 85 "../src/baobab-ringschart.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 85 "../src/baobab-ringschart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_RINGSCHART, BaobabRingschart);
#line 86 "../src/baobab-ringschart.vala"
	g_signal_connect_object ((GObject*) self, "notify::max-depth", (GCallback) _baobab_ringschart_subtips_update_g_object_notify, self, 0);
#line 87 "../src/baobab-ringschart.vala"
	g_signal_connect_object ((GObject*) self, "notify::highlighted-item", (GCallback) _baobab_ringschart_subtips_update_g_object_notify, self, 0);
#line 88 "../src/baobab-ringschart.vala"
	g_signal_connect_object ((GObject*) self, "notify::root", (GCallback) _baobab_ringschart_subtips_update_g_object_notify, self, 0);
#line 85 "../src/baobab-ringschart.vala"
	return obj;
#line 1914 "baobab-ringschart.c"
}

static void
baobab_ringschart_class_init (BaobabRingschartClass * klass,
                              gpointer klass_data)
{
#line 45 "../src/baobab-ringschart.vala"
	baobab_ringschart_parent_class = g_type_class_peek_parent (klass);
#line 45 "../src/baobab-ringschart.vala"
	g_type_class_adjust_private_offset (klass, &BaobabRingschart_private_offset);
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->create_new_chartitem = (BaobabChartItem* (*) (BaobabChart*)) baobab_ringschart_real_create_new_chartitem;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->post_draw = (void (*) (BaobabChart*, cairo_t*)) baobab_ringschart_real_post_draw;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->draw_item = (void (*) (BaobabChart*, cairo_t*, BaobabChartItem*, gboolean)) baobab_ringschart_real_draw_item;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->calculate_item_geometry = (void (*) (BaobabChart*, BaobabChartItem*)) baobab_ringschart_real_calculate_item_geometry;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->get_item_rectangle = (void (*) (BaobabChart*, BaobabChartItem*)) baobab_ringschart_real_get_item_rectangle;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->is_point_over_item = (gboolean (*) (BaobabChart*, BaobabChartItem*, gdouble, gdouble)) baobab_ringschart_real_is_point_over_item;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->can_zoom_out = (gboolean (*) (BaobabChart*)) baobab_ringschart_real_can_zoom_out;
#line 45 "../src/baobab-ringschart.vala"
	((BaobabChartClass *) klass)->can_zoom_in = (gboolean (*) (BaobabChart*)) baobab_ringschart_real_can_zoom_in;
#line 45 "../src/baobab-ringschart.vala"
	G_OBJECT_CLASS (klass)->constructor = baobab_ringschart_constructor;
#line 45 "../src/baobab-ringschart.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_ringschart_finalize;
#line 82 "../src/baobab-ringschart.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "ringschart");
#line 1947 "baobab-ringschart.c"
}

static void
baobab_ringschart_instance_init (BaobabRingschart * self,
                                 gpointer klass)
{
#line 45 "../src/baobab-ringschart.vala"
	self->priv = baobab_ringschart_get_instance_private (self);
#line 54 "../src/baobab-ringschart.vala"
	self->priv->tips_timeout_id = (guint) 0;
#line 55 "../src/baobab-ringschart.vala"
	self->priv->drawing_subtips = FALSE;
#line 1960 "baobab-ringschart.c"
}

static void
baobab_ringschart_finalize (GObject * obj)
{
	BaobabRingschart * self;
#line 45 "../src/baobab-ringschart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_RINGSCHART, BaobabRingschart);
#line 56 "../src/baobab-ringschart.vala"
	(self->priv->subtip_items == NULL) ? NULL : (self->priv->subtip_items = (_g_list_free__baobab_chart_item_unref0_ (self->priv->subtip_items), NULL));
#line 45 "../src/baobab-ringschart.vala"
	G_OBJECT_CLASS (baobab_ringschart_parent_class)->finalize (obj);
#line 1973 "baobab-ringschart.c"
}

static GType
baobab_ringschart_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabRingschartClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_ringschart_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabRingschart), 0, (GInstanceInitFunc) baobab_ringschart_instance_init, NULL };
	GType baobab_ringschart_type_id;
	baobab_ringschart_type_id = g_type_register_static (BAOBAB_TYPE_CHART, "BaobabRingschart", &g_define_type_info, 0);
	BaobabRingschart_private_offset = g_type_add_instance_private (baobab_ringschart_type_id, sizeof (BaobabRingschartPrivate));
	return baobab_ringschart_type_id;
}

GType
baobab_ringschart_get_type (void)
{
	static volatile gsize baobab_ringschart_type_id__once = 0;
	if (g_once_init_enter (&baobab_ringschart_type_id__once)) {
		GType baobab_ringschart_type_id;
		baobab_ringschart_type_id = baobab_ringschart_get_type_once ();
		g_once_init_leave (&baobab_ringschart_type_id__once, baobab_ringschart_type_id);
	}
	return baobab_ringschart_type_id__once;
}

